#include "butterflies_vital_rates.h"

void bf_add_vital_rates(struct cats_configuration *conf, struct conf_data_butterflies *data)
{
        // number of generations
        register_module_vital_rate(conf, &data->butterfly_generations,"butterflies generations");
        set_vital_rate_name(&data->butterfly_generations, "butterflies generations");
        set_vital_rate_suitability_cutoff_hint(&data->butterfly_generations, HYBRID_SUIT_TS_ZT);
        set_vital_rate_link_hybrid_function(&data->butterfly_generations, conf, LINK_SUITABILITY_SIGMOID);
        set_vital_density(&data->butterfly_generations, NO_DENSITY_DEP);


        // adult to eggs
        register_module_vital_rate(conf, &data->eggs_per_female, "butterflies eggs per female");
        set_vital_rate_name(&data->eggs_per_female, "butterflies eggs per female");
        set_vital_rate_suitability_cutoff_hint(&data->eggs_per_female, HYBRID_SUIT_TS_OT);
        set_vital_rate_link_hybrid_function(&data->eggs_per_female, conf, LINK_CONSTANT);

        // eggs to adults
        register_module_vital_rate(conf, &data->reproduction_rate, "butterflies reproduction rate");
        set_vital_rate_name(&data->reproduction_rate, "butterflies reproduction rate");
        set_vital_rate_link_hybrid_function(&data->reproduction_rate, conf, LINK_SUITABILITY_SIGMOID);
        set_vital_rate_suitability_cutoff_hint(&data->reproduction_rate, HYBRID_SUIT_TS_OT);
}
